#ifndef __WRAPPERS_H__
#define __WRAPPERS_H__

#include "stack.h"
#include "integer.h"

MPI *GCD_W(Stack s); 
MPI *LCM_W(Stack s); 
MPI *LCM_ARRAY_W(Stack s); 
MPI *EUCLIDI_W(Stack s); 
MPI *JACOB_W(Stack s); 
MPI *SQRTMX_W(Stack s); 
MPI *GCD_ARRAY_W(Stack s); 
MPI *GCD_ARRAYVX_W(Stack s); 
MPI *CONGRX_W(Stack s); 
MPI *CHINESEX_W(Stack s); 
MPI *CHINESE_ARRAYX_W(Stack s); 
MPI *BIG_MTHROOTX_W(Stack s); 
MPI *FUND_UNITX_W(Stack s); 
MPI *PELX_W(Stack s); 
MPI *SURDX_W(Stack s); 
MPI *MPOWERX_W(Stack s); 
MPI *Nextprime_W(Stack s); 
MPI *INVERSEMX_W(Stack s); 
MPI *FACTORX_W(Stack s); 
MPI *DIVISORX_W(Stack s); 
MPI *MOBIUSX_W(Stack s); 
MPI *EULERX_W(Stack s); 
MPI *SIGMAX_W(Stack s); 
MPI *LPRIMROOTX_W(Stack s); 
MPI *ORDERMX_W(Stack s); 
MPI *LUCASX_W(Stack s); 
MPI *LENGTHX_W(Stack s); 
MPI *RSAE_W(Stack s); 
MPI *NEXTPRIMEAPX_W(Stack s); 
MPI *POLLARD_W(Stack s); 
MPI *EFACTORX_W(Stack s); 
MPI *PERFECT_POWER_W(Stack s); 
MPI *RANDOMI_W(Stack s); 
MPI *LEASTQNRX_W(Stack s); 
MPI* CONTENTPI2_W(Stack s);
MPI* PRIME_GENERATOR_W(Stack s);
MPI *PEL4X_W(Stack s); 

void SERRET_W(Stack s);
void COLLATZ_W(Stack s);
void MTHROOTX_W(Stack s);
void MILLERX_W(Stack s);
void JUGGLER_W(Stack s);
void ENCODE_W(Stack s);
void DECODEX_W(Stack s);
void SCHNORRGCD_W(Stack s);
void SCHNORRHERMITE_W(Stack s);

void EUCLID_W(Stack s);
void CONVERGENTS_W(Stack s);
void LAGRANGE_W(Stack s);

void AXB1_W(Stack s);

void INTLOG(Stack s);
void INTLOG1(Stack s);
void INTLOG2(Stack s);
void LOG2(Stack s);
void LOG1(Stack s);
void LOGG(Stack s);
void LOGGG(Stack s);
void SQROOT1_W(Stack s);
void SQROOT2_W(Stack s);
void SQROOT3_W(Stack s);
MPI *SQROOT_W(Stack s);
void CORNACCHIA_W(Stack s);
void PATZ_W(Stack);
void SHANKSLOG(Stack s);
MPI *QUADRATIC_W(Stack s);
void GAUSS_W(Stack s);
void BINFORM_W(Stack s);
MPI *HALFMOD_W(Stack s);
void LOG_W(Stack s);
POLYI PRIMITIVEPI_W(Stack s);
MPI *CEILINGI_W(Stack s);
void TESTLOG1_W(Stack s);
void TESTLOG_W(Stack s);
MPI *SUBRESULTANT_W(Stack s);
MPI *DISCRIMINANTPI_W(Stack s);
POLYI DERIVPI_W(Stack s);
POLYI GCDPI_W(Stack s);
MPI *STURM_SEQUENCE_W(Stack s);
POLYI CYCLOTOMIC_W(Stack s);
MPI *POS_W(Stack s);
MPI *NEG_W(Stack s);
MPI *NEARINT_W(Stack s);
MPI *REDUCE_NEG_W(Stack s);
MPI *REDUCE_POS_W(Stack s);
MPI *POS0_W(Stack s);
MPI *TABLENEG_W(Stack s);
MPI *TABLEPOS_W(Stack s);
MPI *DAVISON_W(Stack s);
MPI *RANEY1_W(Stack s);
MPI *UNIMODULAR_W(Stack s);
void TWOADICSQRT_W(Stack s);
void PADICSQRT_W(Stack s);
MPI *SIGMAK_W(Stack s);
MPI *TAU_W(Stack s);
MPI *TAU_PRIMEPOWER_W(Stack s);
MPI *TAU_COMPOSITE_W(Stack s);
MPI *REP_DEFINITE_W(Stack s);
void POWERD_W(Stack s);
MPI *EUCLIDI1_W(Stack s);
MPI *CFRACN_W(Stack s);
MPI *CFRAC_PERIOD_W(Stack s);
void MIDPT_COUNT_W(Stack s);
MPI *NSCF_PERIOD_W(Stack s);
void CFRAC_COUNT_W(Stack s);
void SPIRAL_W(Stack s);
MPI *SPIRAL_INVERSE_W(Stack s);
MPI *NICF_PERIOD_W(Stack s);
MPI *NSCF_PERIOD0_W(Stack s);
MPI *RCF_PERIOD0_W(Stack s);
MPI *NICF_PERIOD0_W(Stack s);
void TIME_COUNT_RCF_W(Stack s);
void TIME_COUNT_NICF_W(Stack s);
void TIME_COUNT_NSCF_W(Stack s);
void PERIOD_TIME_COUNT_RCF_W(Stack s);
void PERIOD_TIME_COUNT_NSCF_W(Stack s);
void PERIOD_TIME_COUNT_NICF_W(Stack s);
void TIME_COUNT_RCF00_W(Stack s);
void TIME_COUNT_NICF00_W(Stack s);
void TIME_COUNT_NSCF00_W(Stack s);
void TIME_COUNT_RCF000_W(Stack s);
void TIME_COUNT_NSCF000_W(Stack s);
void TIME_COUNT_NICF000_W(Stack s);
void TIME_COUNT_RCF00_D_W(Stack s);
void TIME_COUNT_NSCF00_D_W(Stack s);
void TIME_COUNT_NICF00_D_W(Stack s);
MPI *CFRAC_PERIOD1_W(Stack s);
void PERIOD_TIME_COUNT_RCF1_W(Stack s);
void PERIOD_TIME_COUNT_NSCF1_W(Stack s);
void PERIOD_TIME_COUNT_NICF1_W(Stack s);
MPI *NSCF_PERIOD1_W(Stack s);
MPI *NICF_PERIOD1_W(Stack s);
void TIME_COUNT_RCF_QIMPROVED_W(Stack s);
void TIME_COUNT_NICF_QIMPROVED_W(Stack s);
MPI *DIVISOR_PMINUS1_W(Stack s);
void SORT_ARRAY_MPI_W(Stack s);
void CARMICHAEL_W(Stack s);
MPI *TANGENT_W(Stack s);
void BERNOULLI_W(Stack s);
MPI *PARTITION_W(Stack s);
void EXCEPTIONALS_W(Stack s);
void EXCEPTIONALS0_W(Stack s);
POLYI FGPI_W(Stack s);
void EXCEPTIONALS10_W(Stack s);
void GPLUS_W(Stack s);
void GZERO_W(Stack s);
void GMINUS_W(Stack s);
void NAGELL_W(Stack s);
void FRATTINI_W(Stack s);
void KASHIHARA_W(Stack s);
void BRANCH_W(Stack s);
MPI *TERNARY_W(Stack s); 
MPI *STOLT_W(Stack s); 
MPI *MIN_MPI_ARRAY_W(Stack s); 
MPI *MIN_MPI__ARRAY_W(Stack s); 
MPI *LPRIME_FACTORX_W(Stack s); 
MPI *CONWAY_CYCLESX_W(Stack s); 
MPI *CONWAY_CYCLES0X_W(Stack s); 
void CONWAY_RANGE_TEST_W(Stack s);
void CONWAY_RANGE_TEST1_W(Stack s);
void TESTLOG2019_W(Stack s);
void BINARYFORM_W(Stack s); 
void BINARYGEN_W(Stack s); 
MPI *DIVISORLIST_W(Stack s); 
#endif
